import { EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { Transformer, Toggle, Supplier } from 'ui-model';
import { Subject } from 'rxjs/Subject';
import { Subscription } from 'rxjs/Subscription';
import { ControlValueAccessor } from '@angular/forms';
import { SafeHtml } from '@angular/platform-browser';
import 'rxjs/add/operator/skipWhile';
import 'rxjs/add/operator/do';
export declare class TypeAheadComponent<T extends {
    format?: Supplier<SafeHtml>;
    parse?: Supplier<string>;
}> implements ControlValueAccessor, OnInit, OnDestroy {
    dropDown: Toggle;
    checker: Subject<{}>;
    items: T[];
    displayField: string;
    placeholder: string;
    formatter: Transformer<any, SafeHtml>;
    parser: Transformer<any, string>;
    search: EventEmitter<string>;
    defaultFormatter(value: T): string | SafeHtml;
    defaultParser(value: T): string;
    constructor();
    sub: Subscription;
    ngOnInit(): void;
    ngOnDestroy(): void;
    term: string;
    _value: T;
    value: T;
    _change: (value: T) => void;
    _touched: () => void;
    protected changed(): void;
    writeValue(value: T): void;
    registerOnChange(fn: (value: T) => void): void;
    registerOnTouched(fn: () => void): void;
    select(item: T): void;
    clear(): void;
}
