"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var ui_model_1 = require('ui-model');
var Subject_1 = require('rxjs/Subject');
var forms_1 = require('@angular/forms');
require('rxjs/add/operator/skipWhile');
require('rxjs/add/operator/do');
var TYPE_AHEAD_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return TypeAheadComponent; }),
    multi: true,
};
var TypeAheadComponent = (function () {
    function TypeAheadComponent() {
        this.dropDown = new ui_model_1.Toggle();
        this.checker = new Subject_1.Subject();
        this.displayField = 'name';
        this.placeholder = '-';
        this.formatter = this.defaultFormatter.bind(this);
        this.parser = this.defaultParser.bind(this);
        this.search = new core_1.EventEmitter();
        this.term = '';
    }
    TypeAheadComponent.prototype.defaultFormatter = function (value) {
        if (!value) {
            return '';
        }
        if (value.hasOwnProperty('format') && ui_model_1.isFunction(value.format)) {
            return value.format();
        }
        else {
            return value[this.displayField];
        }
    };
    ;
    TypeAheadComponent.prototype.defaultParser = function (value) {
        if (!value) {
            return '';
        }
        if (value.hasOwnProperty('parse') && ui_model_1.isFunction(value.format)) {
            return value.parse();
        }
        else {
            return value[this.displayField];
        }
    };
    TypeAheadComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.sub = this.checker.asObservable()
            .skipWhile(function (term) { return !term; })
            .debounceTime(200)
            .do(function () {
            _this.search.emit(_this.term);
        })
            .subscribe(function () {
            _this.dropDown.open();
        });
    };
    TypeAheadComponent.prototype.ngOnDestroy = function () {
        this.checker.complete();
        this.sub.unsubscribe();
    };
    Object.defineProperty(TypeAheadComponent.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (value) {
            this._value = value;
            this.term = value && this.parser(value);
        },
        enumerable: true,
        configurable: true
    });
    TypeAheadComponent.prototype.changed = function () {
        if (this._change) {
            this._change(this.value);
        }
    };
    TypeAheadComponent.prototype.writeValue = function (value) {
        this.value = value;
    };
    TypeAheadComponent.prototype.registerOnChange = function (fn) {
        this._change = fn;
    };
    TypeAheadComponent.prototype.registerOnTouched = function (fn) {
        this._touched = fn;
    };
    TypeAheadComponent.prototype.select = function (item) {
        this.value = item;
        this.changed();
    };
    TypeAheadComponent.prototype.clear = function () {
        this.select(undefined);
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], TypeAheadComponent.prototype, "items", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], TypeAheadComponent.prototype, "displayField", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], TypeAheadComponent.prototype, "placeholder", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Function)
    ], TypeAheadComponent.prototype, "formatter", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Function)
    ], TypeAheadComponent.prototype, "parser", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], TypeAheadComponent.prototype, "search", void 0);
    TypeAheadComponent = __decorate([
        core_1.Component({
            selector: 'ui-type-ahead',
            templateUrl: './type-ahead.component.html',
            styleUrls: ['./type-ahead.component.scss'],
            providers: [TYPE_AHEAD_ACCESSOR],
        }), 
        __metadata('design:paramtypes', [])
    ], TypeAheadComponent);
    return TypeAheadComponent;
}());
exports.TypeAheadComponent = TypeAheadComponent;

//# sourceMappingURL=type-ahead.component.js.map
